
set runCompleted 1
proc APSRun {widget args} {
    set unixCommand ""
    APSStrictParseArguments {unixCommand}
    global runCompleted 
    if !$runCompleted {
	APSSetVarAndUpdate status "Still running last command. Please wait."
	bell
	return 
    }
    set runCompleted 0
    set commandList [split $unixCommand ";"]
    foreach unixCommand $commandList {
	set unixCommand [string trim $unixCommand]
	if [string match *& [string trim $unixCommand]]==1 {
	    set unixCommand [string trim $unixCommand " &"]
	    set runCompleted 1
	}
	APSSetVarAndUpdate status "[clock format [clock seconds]  -format %H:%M:%S]: running"
	APSExecLog $widget -unixCommand $unixCommand -width 80 \
	    -callback "set runCompleted 1" \
	    -cancelCallback "set runCompleted 1" \
	    -abortCallback "set runCompleted 1"
	if !$runCompleted {
	    tkwait variable runCompleted
	}
	bell
	after 50
	bell
	after 50
	bell
	APSSetVarAndUpdate status "[clock format [clock seconds] -format %H:%M:%S]: done"
    }
    return 1
}

proc setRingValues {} {
    global Ring RingRoot Value config

    set index [lsearch [lindex $config(Column.Rootname) 0] $Ring]

    if $index==-1 {
	return -code error "Unknown ring: $Ring"
    }

    set RingRoot $Ring/$Ring
    set columnList $config(ColumnNames)
    foreach item $columnList {
	if [string compare Ring $item]==0 continue
	set varName $item
	if [string match Default* $item] {
	    set varName [os editstring %/Default// $item]
	}
	global $varName
	set $varName [lindex [lindex $config(Column.$item) 0] $index]
    }

    set Value [join [APSReplicateItem -item 0 -number \
	    [llength [split $DriveCorrector ", "]]] ,]
}

if [catch {sdds load config.sdds config} result] {
    return -code error "$result"
}
set Ring [lindex [lindex $config(Column.Rootname) 0] 0]

